Attribute VB_Name = "IDAutomation_UniversalFont_VBA"
'*****************************************************************
'  VBA Functions for IDAutomation Universal Fonts 2014
'   Copyright, 2000-2014 IDAutomation.com, Inc. All rights reserved.
'  Redistribution and use of this code in source and/or binary
'  forms, with or without modification, are permitted provided
'  that: (1) all copies of the source code retain the above
'  unmodified copyright notice and this entire unmodified
'  section of text, (2) You or Your organization owns a
'  valid License to this product from IDAutomation.com
'  and, (3) when any portion of this code is bundled in any
'  form with an application, a valid notice must be provided
'  within the user documentation, start-up screen or in the
'  help-about section of the application that specifies
'  IDAutomation.com as the provider of the Software bundled
'  with the application.
'*****************************************************************

Private I As Integer
Private J As Integer
Private DataToPrint As String
Private OnlyCorrectData As String
Private Encoding As String
Private WeightedTotal As Long
Private WeightValue As Integer
Private CurrentValue As Long
Private CheckDigitValue As Integer
Private Factor As Integer
Private CheckDigit As Integer
Private CurrentEncoding As String
Private NewLine As String
Private CurrentChar As String
Private CurrentCharNum As Integer
Private C128_StartA As String
Private C128_StartB As String
Private C128_StartC As String
Private C128_Stop As String
Private C128Start As String
Private C128CheckDigit As String
Private StartCode As String
Private StopCode As String
Private LeadingDigit As Integer
Private EAN2AddOn As String
Private EAN5AddOn As String
Private EANAddOnToPrint As String
Private HumanReadableText As String
Private StringLength As Integer
Private Char1 As String
Private Char2 As String
Private nwPattern As String
Private CorrectFNC As Integer
Private Idx As Integer
Private PrintableString As String
'Symbology set Arrays
Private SetC128() As Variant
Private SetITF() As Variant
Private Set39() As Variant
Private SetCODABAR() As Variant
Private SetMSI() As Variant
Private SetPostnet() As Variant
Private SetPlanet() As Variant
Private Set93() As Variant

'END OF DECLARACTIONS

Public Function IDAutomation_Uni_C128a(DataToEncode As String) As String
    PrintableString = ""
    SetC128 = Array("EFF", "FEF", "FFE", "BBG", "BCF", "CBF", "BFC", "BGB", "CFB", "FBC", "FCB", "GBB", "AFJ", "BEJ", "BFI", "AJF", "BIF", "BJE", "FJA", "FAJ", "FBI", "EJB", "FIB", "IEI", "IBF", "JAF", "JBE", "IFB", "JEB", "JFA", "EEG", "EGE", "GEE", "ACG", "CAG", "CCE", "AGC", "CEC", "CGA", "ECC", "GAC", "GCA", "AEK", "AGI", "CEI", "AIG", "AKE", "CIE", "IIE", "ECI", "GAI", "EIC", "EKA", "EII", "IAG", "ICE", "KAE", "IEC", "IGA", "KEA", "IMA", "FDA", "OAA", "ABH", "ADF", "BAH", "BDE", "DAF", "DBE", "AFD", "AHB", "BED", "BHA", "DEB", "DFA", "HBA", "FAD", "MIA", "HAB", "CMA", "ABN", "BAN", "BBM", "ANB", "BMB", "BNA", "MBB", "NAB", "NBA", "EEM", "EME", "MEE", "AAO", "ACM", "CAM", "AMC", "AOA", "MAC", "MCA", "AIM", "AMI", "IAM", "MAI", "EDB", "EBD", "EBJ")

    WeightedTotal = 103
    PrintableString = SetC128(103)
    StringLength = Len(DataToEncode)
    For I = 1 To StringLength
         CurrentCharNum = (AscW(Mid(DataToEncode, I, 1))) - 32
         CurrentValue = CurrentCharNum * I
         WeightedTotal = WeightedTotal + CurrentValue
         'PrintableString = PrintableString & ChrW(CurrentCharNum)
         PrintableString = PrintableString & SetC128(CurrentCharNum)
    Next I
    CheckDigitValue = (WeightedTotal Mod 103)
    PrintableString = PrintableString & SetC128(CheckDigitValue)
    'GIAH produces the stop character.
    IDAutomation_Uni_C128a = PrintableString & "GIAH"
    'SetC128 = Null
    DataToEncode = ""
End Function

Public Function IDAutomation_Uni_C128b(DataToEncode As String) As String
    PrintableString = ""
    SetC128 = Array("EFF", "FEF", "FFE", "BBG", "BCF", "CBF", "BFC", "BGB", "CFB", "FBC", "FCB", "GBB", "AFJ", "BEJ", "BFI", "AJF", "BIF", "BJE", "FJA", "FAJ", "FBI", "EJB", "FIB", "IEI", "IBF", "JAF", "JBE", "IFB", "JEB", "JFA", "EEG", "EGE", "GEE", "ACG", "CAG", "CCE", "AGC", "CEC", "CGA", "ECC", "GAC", "GCA", "AEK", "AGI", "CEI", "AIG", "AKE", "CIE", "IIE", "ECI", "GAI", "EIC", "EKA", "EII", "IAG", "ICE", "KAE", "IEC", "IGA", "KEA", "IMA", "FDA", "OAA", "ABH", "ADF", "BAH", "BDE", "DAF", "DBE", "AFD", "AHB", "BED", "BHA", "DEB", "DFA", "HBA", "FAD", "MIA", "HAB", "CMA", "ABN", "BAN", "BBM", "ANB", "BMB", "BNA", "MBB", "NAB", "NBA", "EEM", "EME", "MEE", "AAO", "ACM", "CAM", "AMC", "AOA", "MAC", "MCA", "AIM", "AMI", "IAM", "MAI", "EDB", "EBD", "EBJ")

    WeightedTotal = 104
    PrintableString = SetC128(104)
    StringLength = Len(DataToEncode)
    For I = 1 To StringLength
         CurrentCharNum = (AscW(Mid(DataToEncode, I, 1))) - 32
         CurrentValue = CurrentCharNum * I
         WeightedTotal = WeightedTotal + CurrentValue
         PrintableString = PrintableString & SetC128(CurrentCharNum)
    Next I
    CheckDigitValue = (WeightedTotal Mod 103)
    PrintableString = PrintableString & SetC128(CheckDigitValue)
    'GIAH produces the stop character.
    IDAutomation_Uni_C128b = PrintableString & "GIAH"
    'SetC128 = Null
    DataToEncode = ""
End Function

Public Function IDAutomation_Uni_C128c(DataToEncode As String) As String
    PrintableString = ""
    OnlyCorrectData = ""
    SetC128 = Array("EFF", "FEF", "FFE", "BBG", "BCF", "CBF", "BFC", "BGB", "CFB", "FBC", "FCB", "GBB", "AFJ", "BEJ", "BFI", "AJF", "BIF", "BJE", "FJA", "FAJ", "FBI", "EJB", "FIB", "IEI", "IBF", "JAF", "JBE", "IFB", "JEB", "JFA", "EEG", "EGE", "GEE", "ACG", "CAG", "CCE", "AGC", "CEC", "CGA", "ECC", "GAC", "GCA", "AEK", "AGI", "CEI", "AIG", "AKE", "CIE", "IIE", "ECI", "GAI", "EIC", "EKA", "EII", "IAG", "ICE", "KAE", "IEC", "IGA", "KEA", "IMA", "FDA", "OAA", "ABH", "ADF", "BAH", "BDE", "DAF", "DBE", "AFD", "AHB", "BED", "BHA", "DEB", "DFA", "HBA", "FAD", "MIA", "HAB", "CMA", "ABN", "BAN", "BBM", "ANB", "BMB", "BNA", "MBB", "NAB", "NBA", "EEM", "EME", "MEE", "AAO", "ACM", "CAM", "AMC", "AOA", "MAC", "MCA", "AIM", "AMI", "IAM", "MAI", "EDB", "EBD", "EBJ")

    'Check to make sure data is numeric and remove dashes, etc.
    StringLength = Len(DataToEncode)
    For Idx = 1 To StringLength
       'Add all numbers to OnlyCorrectData string
       If IsNumeric(Mid(DataToEncode, Idx, 1)) = True Then
           OnlyCorrectData = OnlyCorrectData & Mid(DataToEncode, Idx, 1)
       End If
    Next Idx
    DataToEncode = OnlyCorrectData
    If (Len(DataToEncode) Mod 2) = 1 Then DataToEncode = "0" & DataToEncode
    WeightedTotal = 105
    WeightValue = 1
    PrintableString = SetC128(105)
    StringLength = Len(DataToEncode)
    For I = 1 To StringLength Step 2
         CurrentValue = Val(Mid(DataToEncode, I, 2))
         PrintableString = PrintableString & SetC128(CurrentValue)
         CurrentValue = CurrentValue * WeightValue
         WeightedTotal = WeightedTotal + CurrentValue
         WeightValue = WeightValue + 1
    Next I
    CheckDigitValue = (WeightedTotal Mod 103)
    PrintableString = PrintableString & SetC128(CheckDigitValue)
    'GIAH produces the stop character.
    IDAutomation_Uni_C128c = PrintableString & "GIAH"
    DataToEncode = ""
End Function

Public Function IDAutomation_Uni_UCC128(TextToEncode As String) As String
    CurrentCharNum = AscW(Mid(TextToEncode, 1, 1))
    If ((CurrentCharNum = 202) Or ((CurrentCharNum > 211) And (CurrentCharNum < 219))) Then
        'do nothing, AI is already in the data
    Else
        TextToEncode = ChrW(202) & TextToEncode
    End If
    IDAutomation_Uni_UCC128 = IDAutomation_Uni_C128(TextToEncode, True)
End Function


Public Function IDAutomation_Uni_C128(DataToFormat As String, Optional ApplyTilde As Boolean = False) As String
    CorrectFNC = 0
    'in case ApplyTilde is null, set it to false
    If ApplyTilde <> True Then ApplyTilde = False
    PrintableString = ""
    Dim DataToEncode As String
    DataToEncode = DataToFormat
    
    '2007.8 TB added the next line to move code to the IDAutomation_Uni_ProcessTilde function
    If ApplyTilde Then DataToEncode = IDAutomation_Uni_ProcessTilde(DataToEncode)
    
    DataToFormat = DataToEncode
    DataToEncode = ""
    SetC128 = Array("EFF", "FEF", "FFE", "BBG", "BCF", "CBF", "BFC", "BGB", "CFB", "FBC", "FCB", "GBB", "AFJ", "BEJ", "BFI", "AJF", "BIF", "BJE", "FJA", "FAJ", "FBI", "EJB", "FIB", "IEI", "IBF", "JAF", "JBE", "IFB", "JEB", "JFA", "EEG", "EGE", "GEE", "ACG", "CAG", "CCE", "AGC", "CEC", "CGA", "ECC", "GAC", "GCA", "AEK", "AGI", "CEI", "AIG", "AKE", "CIE", "IIE", "ECI", "GAI", "EIC", "EKA", "EII", "IAG", "ICE", "KAE", "IEC", "IGA", "KEA", "IMA", "FDA", "OAA", "ABH", "ADF", "BAH", "BDE", "DAF", "DBE", "AFD", "AHB", "BED", "BHA", "DEB", "DFA", "HBA", "FAD", "MIA", "HAB", "CMA", "ABN", "BAN", "BBM", "ANB", "BMB", "BNA", "MBB", "NAB", "NBA", "EEM", "EME", "MEE", "AAO", "ACM", "CAM", "AMC", "AOA", "MAC", "MCA", "AIM", "AMI", "IAM", "MAI", "EDB", "EBD", "EBJ")
    'Here we select character set A, B or C for the START character
    'Start A = "EDB"
    'Start B = "EBD"
    'Start C = "EBJ"
    StringLength = Len(DataToFormat)
    CurrentCharNum = AscW(Mid(DataToFormat, 1, 1))
    'Set A?
    If CurrentCharNum < 32 Then C128Start = "EDB"
    'Set B?
    If CurrentCharNum > 31 And CurrentCharNum < 127 Then C128Start = "EBD"
    If CurrentCharNum = 197 Then C128Start = "EBD"
    
    'Updated V5.08 by BDA
    'Set C?
    If ((StringLength > 3) And IsNumeric(Mid(DataToFormat, 1, 4))) Then C128Start = "EBJ"
    
    '202 & 212-215 is for the FNC1, with this Start C is mandatory
    If CurrentCharNum = 202 Then C128Start = "EBJ"
    If CurrentCharNum > 211 Then C128Start = "EBJ"
    If C128Start = "EDB" Then CurrentEncoding = "A"
    If C128Start = "EBD" Then CurrentEncoding = "B"
    If C128Start = "EBJ" Then CurrentEncoding = "C"
    For I = 1 To StringLength
        CurrentCharNum = AscW(Mid(DataToFormat, I, 1))
        'check for FNC1 in any set which is ASCII 202 and ASCII 212-215
        If ((CurrentCharNum > 201) And (CurrentCharNum < 219)) Then
            DataToEncode = DataToEncode & ChrW(202)
        'check for switching to character set C
        ElseIf CurrentCharNum = 195 Then
            If CurrentEncoding = "C" Then
                DataToEncode = DataToEncode & ChrW(200)
                CurrentEncoding = "B"
            End If
            DataToEncode = DataToEncode & ChrW(195)
        ElseIf CurrentCharNum = 196 Then
            If CurrentEncoding = "C" Then
                DataToEncode = DataToEncode & ChrW(200)
                CurrentEncoding = "B"
            End If
            DataToEncode = DataToEncode & ChrW(196)
        ElseIf CurrentCharNum = 197 Then  'herb moved check for FNC2 here so that characters do not get skipped
            If CurrentEncoding = "C" Then 'switch to B
                DataToEncode = DataToEncode & ChrW(200)
                CurrentEncoding = "B"
            End If
            DataToEncode = DataToEncode & ChrW(197)
        ElseIf CurrentCharNum = 198 Then
            If CurrentEncoding = "C" Then
                DataToEncode = DataToEncode & ChrW(200)
                CurrentEncoding = "B"
            End If
            DataToEncode = DataToEncode & ChrW(198)
        ElseIf CurrentCharNum = 200 Then
            If CurrentEncoding = "C" Then
                DataToEncode = DataToEncode & ChrW(200)
                CurrentEncoding = "B"
            End If
            DataToEncode = DataToEncode & ChrW(200)
        ElseIf ((I < StringLength - 2) And (IsNumeric(Mid(DataToFormat, I, 1))) And (IsNumeric(Mid(DataToFormat, I + 1, 1))) And (IsNumeric(Mid(DataToFormat, I, 4)))) Or ((I < StringLength) And (IsNumeric(Mid(DataToFormat, I, 1))) And (IsNumeric(Mid(DataToFormat, I + 1, 1))) And (CurrentEncoding = "C")) Then
        
            'Updated V5.12 by BDA 11-22-2005
            'check to see if we have an odd number of numbers to encode,
            'if so stay in current set and then switch to save space
            If CurrentEncoding <> "C" Then
                J = I
                Factor = 3
                Do While J <= StringLength And IsNumeric(Mid(DataToFormat, J, 1))
                    Factor = 4 - Factor
                    J = J + 1
                Loop
                If Factor = 1 Then
                    'if so stay in current set for 1 character to save space
                    DataToEncode = DataToEncode & ChrW(CurrentCharNum)
                    I = I + 1
                End If
            End If
        
            'switch to set C if not already in it
            If CurrentEncoding <> "C" Then DataToEncode = DataToEncode & ChrW(199)
            CurrentEncoding = "C"
            CurrentChar = Mid(DataToFormat, I, 2)
            CurrentValue = Val(CurrentChar)
            'set the CurrentValue to the number of String CurrentChar
            DataToEncode = DataToEncode & ChrW(CurrentValue + 32)
            I = I + 1
            'check for switching to character set A
        ElseIf (I <= StringLength) And ((AscW(Mid(DataToFormat, I, 1)) < 31) Or ((CurrentEncoding = "A") And (AscW(Mid(DataToFormat, I, 1)) > 32 And (AscW(Mid(DataToFormat, I, 1))) < 96))) Then
            'switch to set A if not already in it
            If CurrentEncoding <> "A" Then DataToEncode = DataToEncode & ChrW(201)
            CurrentEncoding = "A"
            'Get the ASCII value of the next character
            CurrentCharNum = AscW(Mid(DataToFormat, I, 1))
            If CurrentCharNum < 32 Then
                DataToEncode = DataToEncode & ChrW(CurrentCharNum + 96)
            ElseIf CurrentCharNum > 32 Then
                DataToEncode = DataToEncode & ChrW(CurrentCharNum)
            End If
        'check for switching to character set B
        ElseIf (I <= StringLength) And (((AscW(Mid(DataToFormat, I, 1))) > 31) And ((AscW(Mid(DataToFormat, I, 1)))) < 127) Then
            'switch to set B if not already in it
            If CurrentEncoding <> "B" Then DataToEncode = DataToEncode & ChrW(200)
            CurrentEncoding = "B"
            'Get the ASCII value of the next character
            CurrentCharNum = AscW(Mid(DataToFormat, I, 1))
            DataToEncode = DataToEncode & ChrW(CurrentCharNum)
        End If
    Next I
 
    '<<<< Calculate Modulo 103 Check Digit >>>>
    If C128Start = "EDB" Then WeightedTotal = 103 'CurrentEncoding = "A"
    If C128Start = "EBD" Then WeightedTotal = 104 'CurrentEncoding = "B"
    If C128Start = "EBJ" Then WeightedTotal = 105 'CurrentEncoding = "C"
    StringLength = Len(DataToEncode)
    For I = 1 To StringLength
        CurrentCharNum = AscW(Mid(DataToEncode, I, 1))
        If CurrentCharNum < 135 Then CurrentValue = CurrentCharNum - 32
        If CurrentCharNum > 134 Then CurrentValue = CurrentCharNum - 100
        If CurrentCharNum = 194 Then CurrentValue = 0
        PrintableString = PrintableString & SetC128(CurrentValue)
        CurrentValue = CurrentValue * I
        WeightedTotal = WeightedTotal + CurrentValue
    Next I
    CheckDigitValue = (WeightedTotal Mod 103)
    DataToEncode = ""
    'GIAH produces the stop character.
    'Formula = C128Start & PrintableString & SetC128(CheckDigitValue) & ChrW(206) & "GIAH" & "j"
    IDAutomation_Uni_C128 = C128Start & PrintableString & SetC128(CheckDigitValue) & "GIAH"
End Function


Public Function IDAutomation_Uni_C128HR(DataToFormat As String, Optional ApplyTilde As Boolean = True)
'   Dim HumanReadableText As String
    HumanReadableText = ""
    Dim DataToEncode As String
    DataToEncode = DataToFormat
   
    '2007.8 TB added the next line to move code to the IDAutomation_Uni_ProcessTilde function
    If ApplyTilde Then DataToEncode = IDAutomation_Uni_ProcessTilde(DataToEncode)
   
   DataToFormat = DataToEncode
   DataToEncode = ""
   OnlyCorrectData = ""
   HumanReadableText = ""
   'FORMAT TEXT FOR AIs
    StringLength = Len(DataToFormat)
    For I = 1 To StringLength
        CorrectFNC = 0
        'Get ASCII value of each character
        CurrentCharNum = AscW(Mid(DataToFormat, I, 1))
        'Check for FNC1
        If ((I < StringLength - 2) And ((CurrentCharNum = 202) Or ((CurrentCharNum > 211) And (CurrentCharNum < 219)))) Then
            'Updated the next if/else by BDA on 12-2005 to eliminate errors from text after the AI
            'It appears that there is an AI
            'Get the value of the next 2 digits to try to determine the length of the AI, if text is used here
            'Set this value to 81 for a 4 digit AI
            If IsNumeric(Mid(DataToFormat, I + 1, 1)) And IsNumeric(Mid(DataToFormat, I + 2, 1)) Then
                CurrentChar = Mid(DataToFormat, I + 1, 2)
                CurrentCharNum = Val(CurrentChar)
            Else
                CurrentCharNum = 81
            End If
            'Is 2 digit AI by entering ASCII 212?
            If ((CorrectFNC = 0) And (AscW(Mid(DataToFormat, I, 1)) = 212)) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 2)) & ") "
                I = I + 2
                CorrectFNC = 1
            'Is 3 digit AI by entering ASCII 213?
            ElseIf ((I < StringLength - 3) And (CorrectFNC = 0) And (AscW(Mid(DataToFormat, I, 1)) = 213)) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 3)) & ") "
                I = I + 3
                CorrectFNC = 1
            'Is 4 digit AI by entering ASCII 214?
            ElseIf ((I < StringLength - 4) And (CorrectFNC = 0) And (AscW(Mid(DataToFormat, I, 1)) = 214)) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 4)) & ") "
                I = I + 4
                CorrectFNC = 1
            'Is 5 digit AI by entering ASCII 215?
            ElseIf ((I < StringLength - 5) And (CorrectFNC = 0) And (AscW(Mid(DataToFormat, I, 1)) = 215)) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 5)) & ") "
                I = I + 5
                CorrectFNC = 1
            'Is 6 digit AI by entering ASCII 216?
            ElseIf ((I < StringLength - 6) And (CorrectFNC = 0) And (AscW(Mid(DataToFormat, I, 1)) = 216)) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 6)) & ") "
                I = I + 6
                CorrectFNC = 1
            'Is 7 digit AI by entering ASCII 217?
            ElseIf ((I < StringLength - 7) And (CorrectFNC = 0) And (AscW(Mid(DataToFormat, I, 1)) = 217)) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 7)) & ") "
                I = I + 7
                CorrectFNC = 1
            'Is 8 digit AI by entering ASCII 218?
            ElseIf ((I < StringLength - 8) And (CorrectFNC = 0) And (AscW(Mid(DataToFormat, I, 1)) = 218)) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 8)) & ") "
                I = I + 8
                CorrectFNC = 1
            'Is 4 digit AI by detection?
            ElseIf ((I < StringLength - 4) And (CorrectFNC = 0) And ((CurrentCharNum <= 81 And CurrentCharNum >= 80) Or (CurrentCharNum <= 34 And CurrentCharNum >= 31))) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 4)) & ") "
                I = I + 4
                CorrectFNC = 1
            'Is 3 digit AI by detection?
            ElseIf ((I < StringLength - 3) And (CorrectFNC = 0) And ((CurrentCharNum <= 49 And CurrentCharNum >= 40) Or (CurrentCharNum <= 25 And CurrentCharNum >= 23))) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 3)) & ") "
                I = I + 3
                CorrectFNC = 1
            'Is 2 digit AI by detection?
            ElseIf ((CurrentCharNum <= 30 And (CorrectFNC = 0) And CurrentCharNum >= 0) Or (CurrentCharNum <= 99 And CurrentCharNum >= 90)) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 2)) & ") "
                I = I + 2
                CorrectFNC = 1
            'If no AI was detected, set default to 4 digit AI:
            ElseIf ((I < StringLength - 4) And (CorrectFNC = 0)) Then
                HumanReadableText = HumanReadableText & " (" & (Mid(DataToFormat, I + 1, 4)) & ") "
                I = I + 4
                CorrectFNC = 1
            End If
        ElseIf (AscW(Mid(DataToFormat, I, 1)) = 197) Then
            HumanReadableText = HumanReadableText & " "
        ElseIf (AscW(Mid(DataToFormat, I, 1)) < 32) Then
            HumanReadableText = HumanReadableText & " "
        ElseIf ((AscW(Mid(DataToFormat, I, 1)) > 31) And (AscW(Mid(DataToFormat, I, 1)) < 128)) Then
            HumanReadableText = HumanReadableText & Mid(DataToFormat, I, 1)
        End If
    Next I
    DataToFormat = ""
    IDAutomation_Uni_C128HR = HumanReadableText
End Function


Public Function IDAutomation_Uni_SpliceText(DataToFormat As String, Optional SpacingNumber As Integer = 4, Optional ApplyTilde As Boolean = False) As String
    'This function inserts a space for every SpacingNumber of characters
    '2007.8 TB added the next line to move code to the IDAutomation_Uni_ProcessTilde function
    If ApplyTilde Then DataToFormat = IDAutomation_Uni_ProcessTilde(DataToFormat)
    'inserting a space for every SpacingNumber of characters
    HumanReadableText = ""
    StringLength = Len(DataToFormat)
    J = 0
    For I = 1 To StringLength
        CurrentCharNum = AscW(Mid(DataToFormat, I, 1))
        If CurrentCharNum > 31 And CurrentCharNum < 128 Then
            HumanReadableText = HumanReadableText & Mid(DataToFormat, I, 1)
            J = J + 1
        End If
        If (J Mod SpacingNumber) = 0 Then HumanReadableText = HumanReadableText & " "
    Next I
    IDAutomation_Uni_SpliceText = HumanReadableText
End Function

Public Function IDAutomation_Uni_C93(DataToEncode As String) As String
    DataToEncode = UCase(DataToEncode)
    DataToPrint = ""
    OnlyCorrectData = ""
    SetC93 = Array( _
    "CAB", "ABC", "ACB", "ADA", "BAC", "BBB", "BCA", "AAD", "CBA", "DAA", _
    "EAC", "EBB", "ECA", "FAB", "FBA", "GAA", "AEC", "AFB", "AGA", "BEB", _
    "CEA", "AAG", "ABF", "ACE", "BAF", "CAE", "EEB", "EFA", "EAF", "EBE", _
    "FAE", "FEA", "AEF", "AFE", "BEE", "BIA", "BAI", "IAB", "IBA", "JAA", _
    "AEI", "AIE", "EAI", "BBE", "IEA", "IAE", "BFA")
    'Only pass correct data
    StringLength = Len(DataToEncode)
    For I = 1 To StringLength
        CurrentCharNum = AscW(Mid(DataToEncode, I, 1))
        If Code93Val(CurrentCharNum) < 47 Then
            If CurrentCharNum = 32 Then CurrentCharNum = 61
            OnlyCorrectData = OnlyCorrectData & ChrW(CurrentCharNum)
        End If
    Next I
    DataToEncode = OnlyCorrectData
    CurrentCharNum = 0
    StringLength = Len(DataToEncode)
    Dim C As Integer
    Dim K As Integer
    Dim CW As Integer
    Dim KW As Integer
    Dim CWSum As Integer
    Dim KWSum As Integer
    CW = 1
    KW = 2
    I = 1
    For I = StringLength To 1 Step -1
       'Get each character one at a time from the back
       CurrentCharNum = AscW(Mid(DataToEncode, I, 1))
       'Get the value
       CurrentValue = Code93Val(CurrentCharNum)
       'Calculate check digit C
       CWSum = CWSum + (CurrentValue * CW)
       CW = CW + 1
       If CW = 21 Then CW = 1
       'Calculate check digit K
       KWSum = KWSum + (CurrentValue * KW)
       KW = KW + 1
       If KW = 16 Then KW = 1
       'Gather data to print
       '[for standard font] DataToPrint = ChrW(CurrentCharNum) & DataToPrint
       DataToPrint = SetC93(CurrentValue) & DataToPrint
    Next I
    'Divide the C sum by 47 and get the remainder, this is the Check Digit C
    C = (CWSum Mod 47)
    'Add the last digit to the K sum
    KWSum = KWSum + C
    'Divide the K sum by 47 and get the remainder, this is the Check Digit K
    K = (KWSum Mod 47)
    '[for standard font] Code93 = "(" & DataToPrint & Set93(C) & Set93(K) & ")"
    IDAutomation_Uni_C93 = "AAM" & DataToPrint & SetC93(C) & SetC93(K) & "AAMA"
End Function

Private Function Code93Char(CharValue As Integer) As String
    'Returns a character from a character value
    'An invalid character value returns nothing
    Code93Char = ""
    If CharValue < 10 And CharValue > -1 Then Code93Char = ChrW(CharValue + 48)
    'A-Z
    If CharValue < 36 And CharValue > 9 Then Code93Char = ChrW(CharValue + 55)
    '-
    If CharValue = 36 Then Code93Char = ChrW(45)
    '.
    If CharValue = 37 Then Code93Char = "."
    'Space
    If CharValue = 38 Then Code93Char = "="
    '$
    If CharValue = 39 Then Code93Char = "$"
    '/
    If CharValue = 40 Then Code93Char = "/"
    '+
    If CharValue = 41 Then Code93Char = "+"
    '%
    If CharValue = 42 Then Code93Char = "%"
    '!
    If CharValue = 43 Then Code93Char = "!"
    '#
    If CharValue = 44 Then Code93Char = "#"
    '&
    If CharValue = 45 Then Code93Char = "&"
    '@
    If CharValue = 46 Then Code93Char = "@"
End Function

Public Function Code93Val(CharASCValue As Integer) As Integer
    'Returns a character value from a character
    'An invalid character value returns 99
    Code93Val = 99
    '0-9
    If CharASCValue < 58 And CharASCValue > 47 Then Code93Val = CharASCValue - 48
    'A-Z
    If CharASCValue < 91 And CharASCValue > 64 Then Code93Val = CharASCValue - 55
    'Space
    If CharASCValue = 32 Then Code93Val = 38
    '=
    If CharASCValue = 61 Then Code93Val = 38
    '-
    If CharASCValue = 45 Then Code93Val = 36
    '.
    If CharASCValue = 46 Then Code93Val = 37
    '$
    If CharASCValue = 36 Then Code93Val = 39
    '/
    If CharASCValue = 47 Then Code93Val = 40
    '+
    If CharASCValue = 43 Then Code93Val = 41
    '%
    If CharASCValue = 37 Then Code93Val = 42
    '! ($)
    If CharASCValue = 33 Then Code93Val = 43
    '# (%)
    If CharASCValue = 35 Then Code93Val = 44
    '& (/)
    If CharASCValue = 38 Then Code93Val = 45
    '@ (+)
    If CharASCValue = 64 Then Code93Val = 46
End Function

Public Function IDAutomation_Uni_I2of5(DataToEncode As String, Optional N_Dimension As Double, Optional IncludeCheckDigit As Boolean = False) As String
    CurrentEncoding = ""
    DataToPrint = ""
    OnlyCorrectData = ""
    If N_Dimension <> 3 And N_Dimension <> 2.5 Then N_Dimension = 2
    SetITF = Array("nnwwn", "wnnnw", "nwnnw", "wwnnn", "nnwnw", "wnwnn", "nwwnn", "nnnww", "wnnwn", "nwnwn")
    StringLength = Len(DataToEncode)
    For I = 1 To StringLength
         If IsNumeric(Mid(DataToEncode, I, 1)) Then OnlyCorrectData = OnlyCorrectData & Mid(DataToEncode, I, 1)
    Next I
    DataToEncode = OnlyCorrectData
    Factor = 3
    WeightedTotal = 0
    For I = Len(DataToEncode) To 1 Step -1
         CurrentCharNum = Mid(DataToEncode, I, 1)
         WeightedTotal = WeightedTotal + CurrentCharNum * Factor
         Factor = 4 - Factor
    Next I
    'Find the CheckDigit by finding the smallest number that = a multiple of 10
    I = (WeightedTotal Mod 10)
    If I <> 0 Then
         CheckDigit = (10 - I)
    Else
         CheckDigit = 0
    End If
    'Add check digit to DataToEncode
    If IncludeCheckDigit Then DataToEncode = DataToEncode & CheckDigit
    'Check for an even number of digits, add 0 if not even
    If (Len(DataToEncode) Mod 2) = 1 Then DataToEncode = "0" & DataToEncode
    StringLength = Len(DataToEncode)
    For I = 1 To StringLength Step 2
        'Get the value of each number
        Char1 = SetITF(Asc(Mid(DataToEncode, I, 1)) - 48)
        Char2 = SetITF(Asc(Mid(DataToEncode, I + 1, 1)) - 48)
        CurrentEncoding = ""
        If N_Dimension = 3 Then
            For J = 1 To 5
                CurrentEncoding = Mid(Char1, J, 1) & Mid(Char2, J, 1)
                Select Case CurrentEncoding
                    Case "nn"
                        DataToPrint = DataToPrint & "A"
                    Case "nw"
                        DataToPrint = DataToPrint & "C"
                    Case "wn"
                        DataToPrint = DataToPrint & "I"
                    Case "ww"
                        DataToPrint = DataToPrint & "K"
                End Select
            Next
        End If
        If N_Dimension = 2.5 Then
            For J = 1 To 5
                CurrentEncoding = Mid(Char1, J, 1) & Mid(Char2, J, 1)
                Select Case CurrentEncoding
                    Case "nn"
                        DataToPrint = DataToPrint & "W"
                    Case "nw"
                        DataToPrint = DataToPrint & "X"
                    Case "wn"
                        DataToPrint = DataToPrint & "Y"
                    Case "ww"
                        DataToPrint = DataToPrint & "Z"
                End Select
            Next
        End If
        If N_Dimension = 2 Then
            For J = 1 To 5
                CurrentEncoding = Mid(Char1, J, 1) & Mid(Char2, J, 1)
                Select Case CurrentEncoding
                    Case "nn"
                        DataToPrint = DataToPrint & "A"
                    Case "nw"
                        DataToPrint = DataToPrint & "B"
                    Case "wn"
                        DataToPrint = DataToPrint & "E"
                    Case "ww"
                        DataToPrint = DataToPrint & "F"
                End Select
            Next
        End If
    Next I
    If N_Dimension = 3 Then IDAutomation_Uni_I2of5 = "AA" & DataToPrint & "IA"
    If N_Dimension = 2.5 Then IDAutomation_Uni_I2of5 = "WW" & DataToPrint & "YW"
    If N_Dimension = 2 Then IDAutomation_Uni_I2of5 = "AA" & DataToPrint & "EA"
End Function

Public Function IDAutomation_Uni_Postnet(DataToEncode As String, Optional IncludeCheckDigit As Boolean = True) As String
    PrintableString = ""
    OnlyCorrectData = ""
    WeightedTotal = 0
    SetPostnet = Array("mjo", "jkn", "jln", "jmo", "kjn", "kko", "klo", "ljn", "lko", "llo")
    StringLength = Len(DataToEncode)
    For I = 1 To StringLength
         If IsNumeric(Mid(DataToEncode, I, 1)) Then OnlyCorrectData = OnlyCorrectData & Mid(DataToEncode, I, 1)
    Next I
    DataToEncode = OnlyCorrectData
    StringLength = Len(DataToEncode)
    For I = 1 To StringLength
         CurrentCharNum = Val(Mid(DataToEncode, I, 1))
         PrintableString = PrintableString & SetPostnet(CurrentCharNum)
         WeightedTotal = WeightedTotal + CurrentCharNum
    Next I
    I = (WeightedTotal Mod 10)
    If I <> 0 Then
         CheckDigit = (10 - I)
    Else
         CheckDigit = 0
    End If
    If IncludeCheckDigit Then PrintableString = PrintableString & SetPostnet(CheckDigit)
    IDAutomation_Uni_Postnet = "n" & PrintableString & "n"
    DataToEncode = ""
End Function

Public Function IDAutomation_Uni_Planet(DataToEncode As String, Optional IncludeCheckDigit As Boolean = True) As String
    PrintableString = ""
    OnlyCorrectData = ""
    WeightedTotal = 0
    SetPlanet = Array("jmn", "mlo", "mko", "mjn", "lmo", "lln", "lkn", "kmo", "kln", "kkn")
    StringLength = Len(DataToEncode)
    For I = 1 To StringLength
         If IsNumeric(Mid(DataToEncode, I, 1)) Then OnlyCorrectData = OnlyCorrectData & Mid(DataToEncode, I, 1)
    Next I
    DataToEncode = OnlyCorrectData
    StringLength = Len(DataToEncode)
    For I = 1 To StringLength
         CurrentCharNum = Val(Mid(DataToEncode, I, 1))
         PrintableString = PrintableString & SetPlanet(CurrentCharNum)
         WeightedTotal = WeightedTotal + CurrentCharNum
    Next I
    I = (WeightedTotal Mod 10)
    If I <> 0 Then
         CheckDigit = (10 - I)
    Else
         CheckDigit = 0
    End If
    If IncludeCheckDigit Then PrintableString = PrintableString & SetPlanet(CheckDigit)
    IDAutomation_Uni_Planet = "n" & PrintableString & "n"
    DataToEncode = ""
End Function

Public Function IDAutomation_Uni_C39(DataToEncode As String, Optional N_Dimension As Double = 2, Optional IncludeCheckDigit As Boolean = False) As String
    CurrentEncoding = ""
    DataToPrint = ""
    OnlyCorrectData = ""
    If N_Dimension <> 3 And N_Dimension <> 2.5 Then N_Dimension = 2
     
    Set39 = Array("nnnwwnwnnn", "wnnwnnnnwn", "nnwwnnnnwn", "wnwwnnnnnn", "nnnwwnnnwn", "wnnwwnnnnn", "nnwwwnnnnn", "nnnwnnwnwn", "wnnwnnwnnn", "nnwwnnwnnn", "wnnnnwnnwn", "nnwnnwnnwn", "wnwnnwnnnn", "nnnnwwnnwn", "wnnnwwnnnn", "nnwnwwnnnn", "nnnnnwwnwn", "wnnnnwwnnn", "nnwnnwwnnn", "nnnnwwwnnn", "wnnnnnnwwn", "nnwnnnnwwn", "wnwnnnnwnn", "nnnnwnnwwn", "wnnnwnnwnn", "nnwnwnnwnn", "nnnnnnwwwn", "wnnnnnwwnn", "nnwnnnwwnn", "nnnnwnwwnn", "wwnnnnnnwn", "nwwnnnnnwn", "wwwnnnnnnn", "nwnnwnnnwn", "wwnnwnnnnn", "nwwnwnnnnn", "nwnnnnwnwn", "wwnnnnwnnn", "nwwnnnwnnn", "nwnwnwnnnn", "nwnwnnnwnn", "nwnnnwnwnn", "nnnwnwnwnn", "nwnnwnwnnn")
    
    DataToEncode = UCase(DataToEncode)
    StringLength = Len(DataToEncode)
    WeightedTotal = 0
    For I = 1 To StringLength
        'Get the value of each number
        CurrentCharNum = (AscW(Mid(DataToEncode, I, 1)))
        CurrentEncoding = ""
        'Set CurrentValue to an invalid value by default
        CurrentValue = 99
        'Get the C39 value of CurrentChar
        '0-9
        If CurrentCharNum < 58 And CurrentCharNum > 47 Then CurrentValue = CurrentCharNum - 48
        'A-Z
        If CurrentCharNum < 91 And CurrentCharNum > 64 Then CurrentValue = CurrentCharNum - 55
        'Space
        If CurrentCharNum = 32 Then CurrentValue = 38
        '-
        If CurrentCharNum = 45 Then CurrentValue = 36
        '.
        If CurrentCharNum = 46 Then CurrentValue = 37
        '$
        If CurrentCharNum = 36 Then CurrentValue = 39
        '/
        If CurrentCharNum = 47 Then CurrentValue = 40
        '+
        If CurrentCharNum = 43 Then CurrentValue = 41
        '%
        If CurrentCharNum = 37 Then CurrentValue = 42
        
        'add the values together for the check digit
        If CurrentValue <> "99" And IncludeCheckDigit Then WeightedTotal = WeightedTotal + CurrentValue
        
        'retrieve the pattern, for example, 0 = "nnnwwnwnnn"
        If CurrentValue <> "99" Then nwPattern = Set39(CurrentValue)
        
        If N_Dimension = 3 And CurrentValue <> "99" Then
            For J = 1 To 10 Step 2
                CurrentEncoding = Mid(nwPattern, J, 2)
                Select Case CurrentEncoding
                    Case "nn"
                        DataToPrint = DataToPrint & "A"
                    Case "nw"
                        DataToPrint = DataToPrint & "C"
                    Case "wn"
                        DataToPrint = DataToPrint & "I"
                    Case "ww"
                        DataToPrint = DataToPrint & "K"
                End Select
            Next
        End If
        If N_Dimension = 2.5 And CurrentValue <> "99" Then
            For J = 1 To 10 Step 2
                CurrentEncoding = Mid(nwPattern, J, 2)
                Select Case CurrentEncoding
                    Case "nn"
                        DataToPrint = DataToPrint & "W"
                    Case "nw"
                        DataToPrint = DataToPrint & "X"
                    Case "wn"
                        DataToPrint = DataToPrint & "Y"
                    Case "ww"
                        DataToPrint = DataToPrint & "Z"
                End Select
            Next
        End If
        If N_Dimension = 2 And CurrentValue <> "99" Then
            For J = 1 To 10 Step 2
                CurrentEncoding = Mid(nwPattern, J, 2)
                Select Case CurrentEncoding
                    Case "nn"
                        DataToPrint = DataToPrint & "A"
                    Case "nw"
                        DataToPrint = DataToPrint & "B"
                    Case "wn"
                        DataToPrint = DataToPrint & "E"
                    Case "ww"
                        DataToPrint = DataToPrint & "F"
                End Select
            Next
        End If
    Next I
    
    If IncludeCheckDigit Then
        'divide the WeightedTotal by 43 and get the remainder, this is the CheckDigit
        CheckDigitValue = (WeightedTotal Mod 43)
        nwPattern = Set39(CheckDigitValue)
        If N_Dimension = 3 And CurrentValue <> "99" Then
            For J = 1 To 10 Step 2
                CurrentEncoding = Mid(nwPattern, J, 2)
                Select Case CurrentEncoding
                    Case "nn"
                        DataToPrint = DataToPrint & "A"
                    Case "nw"
                        DataToPrint = DataToPrint & "C"
                    Case "wn"
                        DataToPrint = DataToPrint & "I"
                    Case "ww"
                        DataToPrint = DataToPrint & "K"
                End Select
            Next
        End If
        If N_Dimension = 2.5 And CurrentValue <> "99" Then
            For J = 1 To 10 Step 2
                CurrentEncoding = Mid(nwPattern, J, 2)
                Select Case CurrentEncoding
                    Case "nn"
                        DataToPrint = DataToPrint & "W"
                    Case "nw"
                        DataToPrint = DataToPrint & "X"
                    Case "wn"
                        DataToPrint = DataToPrint & "Y"
                    Case "ww"
                        DataToPrint = DataToPrint & "Z"
                End Select
            Next
        End If
        If N_Dimension = 2 And CurrentValue <> "99" Then
            For J = 1 To 10 Step 2
                CurrentEncoding = Mid(nwPattern, J, 2)
                Select Case CurrentEncoding
                    Case "nn"
                        DataToPrint = DataToPrint & "A"
                    Case "nw"
                        DataToPrint = DataToPrint & "B"
                    Case "wn"
                        DataToPrint = DataToPrint & "E"
                    Case "ww"
                        DataToPrint = DataToPrint & "F"
                End Select
            Next
        End If
    End If
    'Add start and stop bars
    If N_Dimension = 3 Then IDAutomation_Uni_C39 = "CAIIA" & DataToPrint & "CAIIA"
    If N_Dimension = 2.5 Then IDAutomation_Uni_C39 = "XWYYW" & DataToPrint & "XWYYW"
    If N_Dimension = 2 Then IDAutomation_Uni_C39 = "BAEEA" & DataToPrint & "BAEEA"
End Function


Public Function MODU10(M10NumberData As String) As Integer
' This is a general MOD10 function like the one required
' for UCC, EAN and UPC barcodes
'********************************************************
     Dim M10StringLength As Integer
     Dim M10OnlyCorrectData As String
     Dim M10Factor As Integer
     Dim M10WeightedTotal As Integer
     Dim M10CheckDigit As Integer
     Dim M10I As Integer
     M10OnlyCorrectData = ""
     M10StringLength = Len(M10NumberData)
     'Check to make sure data is numeric and remove dashes, etc.
     For M10I = 1 To M10StringLength
        'Add all numbers to OnlyCorrectData string
        '2006.2 BDA modified the next 2 lines for compatibility with different office versions
         CurrentCharNum = AscW(Mid(M10NumberData, M10I, 1))
         If CurrentCharNum > 47 And CurrentCharNum < 58 Then M10OnlyCorrectData = M10OnlyCorrectData & Mid(M10NumberData, M10I, 1)
     Next M10I
    'Generate MOD 10 check digit
     M10Factor = 3
     M10WeightedTotal = 0
     M10StringLength = Len(M10NumberData)
     For M10I = M10StringLength To 1 Step -1
    'Get the value of each number starting at the end
    'CurrentCharNum = Mid(M10NumberData, I, 1)
    'Multiply by the weighting factor which is 3,1,3,1...
    'and add the sum together
          M10WeightedTotal = M10WeightedTotal + (Val(Mid(M10NumberData, M10I, 1)) * M10Factor)
          'Change factor for next calculation
          M10Factor = 4 - M10Factor
     Next M10I
    'Find the CheckDigit by finding the smallest number that = a multiple of 10
     M10I = (M10WeightedTotal Mod 10)
     If M10I <> 0 Then
          M10CheckDigit = (10 - M10I)
     Else
          M10CheckDigit = 0
     End If
     MODU10 = Str(M10CheckDigit)
'     Dim M10StringLength As Integer
'     Dim M10OnlyCorrectData As String
'     Dim M10Factor As Integer
'     Dim M10WeightedTotal As Integer
'     Dim M10CheckDigit As Integer
'     Dim M10I As Integer
'
'     M10OnlyCorrectData = ""
'     M10StringLength = Len(M10NumberData)
'     For M10I = 1 To M10StringLength
'        'Add all numbers to OnlyCorrectData string
'          If IsNumeric(Mid(M10NumberData, M10I, 1)) Then M10OnlyCorrectData = M10OnlyCorrectData & Mid(M10NumberData, M10I, 1)
'     Next M10I
'    '<<<< Generate MOD 10 check digit >>>>
'     M10Factor = 3
'     M10WeightedTotal = 0
'     M10StringLength = Len(M10NumberData)
'     For M10I = M10StringLength To 1 Step -1
'    'Get the value of each number starting at the end
'    'CurrentCharNum = Mid(M10NumberData, I, 1)
'    'multiply by the weighting factor which is 3,1,3,1...
'    'and add the sum together
'          M10WeightedTotal = M10WeightedTotal + (Val(Mid(M10NumberData, M10I, 1)) * M10Factor)
'    'change factor for next calculation
'          M10Factor = 4 - M10Factor
'     Next M10I
'    'Find the CheckDigit by finding the smallest number that = a multiple of 10
'     M10I = (M10WeightedTotal Mod 10)
'     If M10I <> 0 Then
'          M10CheckDigit = (10 - M10I)
'     Else
'          M10CheckDigit = 0
'     End If
'     MODU10 = Str(M10CheckDigit)
End Function


Public Function IDAutomation_Uni_MSI(DataToEncode As String, Optional N_Dimension As Double, Optional IncludeCheckDigit As Boolean = True) As String
    Dim OddNumbers As String        'String of odd position numbers used to create check digit
    Dim EvenNumberSum As Long       'all of the even position numbers added up
    Dim OddNumberProduct As Long    'Product of OddNumbers variable
    Dim sOddNumberProduct As String 'String version of OddNumberProduct variable
    Dim OddNumberSum As Long        'Sum of individual digits in sOddNumberProduct
    Dim OddDigit As Boolean         'Used to determine even/odd position digits.
    CurrentEncoding = ""
    DataToPrint = ""
    OnlyCorrectData = ""
    SetMSI = Array("nwnwnwnw", "nwnwnwwn", "nwnwwnnw", "nwnwwnwn", "nwwnnwnw", "nwwnnwwn", "nwwnwnnw", "nwwnwnwn", "wnnwnwnw", "wnnwnwwn")
    If N_Dimension <> 3 And N_Dimension <> 2.5 Then N_Dimension = 2
    
    'Check to make sure data is numeric and remove dashes, etc.
     StringLength = Len(DataToEncode)
     For Idx = 1 To StringLength
        'Add all numbers to OnlyCorrectData string
        If IsNumeric(Mid(DataToEncode, Idx, 1)) = True Then
            OnlyCorrectData = OnlyCorrectData & Mid(DataToEncode, Idx, 1)
        End If
     Next Idx
     DataToEncode = OnlyCorrectData

     '<<<< Calculate Check Digit >>>>
     'To create the check digit follow these steps:
     '1)Starting from the units position, create a new number with all of the odd
     '  position digits in their original sequence.
     '2)Multiply this new number by 2.
     '3)Add all of the digits of the product from step two.
     '4)Add all of the digits not used in step one to the result in step three.
     '5)Determine the smallest number which when added to the result in step four
     '  will result in a multiple of 10. This is the check character.

    'Step 1 -- Create a new number of the odd position digits starting from the right and going left, but store the
    'digits from left to right.
    'Create the odd position number & prepare for Step 4 by getting the sum of all even position characters
    StringLength = Len(DataToEncode)
    OddNumbers = ""
    OddDigit = True
    EvenNumberSum = 0
    For Idx = StringLength To 1 Step -1
        If OddDigit = True Then
            OddNumbers = Mid(DataToEncode, Idx, 1) & OddNumbers
            OddDigit = False
        Else
            EvenNumberSum = EvenNumberSum + Val(Mid(DataToEncode, Idx, 1))
            OddDigit = True
        End If
    Next Idx
    
    'Step 2 -- Multiply this new number by 2.
    OddNumberProduct = Val(OddNumbers) * 2

    'Step 3 -- Add all of the digits of the product from step two.
    sOddNumberProduct = Format(OddNumberProduct)
    StringLength = Len(sOddNumberProduct)
    OddNumberSum = 0

    For Idx = 1 To StringLength
        OddNumberSum = OddNumberSum + Val(Mid(sOddNumberProduct, Idx, 1))
    Next Idx
    
    'Step 4 -- Add all of the digits not used in step one to the result in step three.
    'We will store the result in OddNumberSum just so we don't have to create another variable
    OddNumberSum = OddNumberSum + EvenNumberSum
    
    'Step 5 -- Determine the smallest number which when added to the result in step four
    '  will result in a multiple of 10. This is the check character.
    OddNumberSum = OddNumberSum Mod 10
    If OddNumberSum <> 0 Then
        CheckDigit = Format(10 - OddNumberSum)
    Else
        CheckDigit = "0"
    End If

    'Add the check digit to the string to encode
    If IncludeCheckDigit Then DataToEncode = DataToEncode & CheckDigit
    'Format the string to the universal font
    StringLength = Len(DataToEncode)
    WeightedTotal = 0
    For I = 1 To StringLength
        'Get the value of each number
        CurrentValue = (AscW(Mid(DataToEncode, I, 1))) - 48

        'Retrieve the pattern, for example, 0 = "nwnwnwnw"
        nwPattern = SetMSI(CurrentValue)
        
        If N_Dimension = 3 Then
            For J = 1 To 8 Step 2
                CurrentEncoding = Mid(nwPattern, J, 2)
                Select Case CurrentEncoding
                    Case "nn"
                        DataToPrint = DataToPrint & "A"
                    Case "nw"
                        DataToPrint = DataToPrint & "C"
                    Case "wn"
                        DataToPrint = DataToPrint & "I"
                    Case "ww"
                        DataToPrint = DataToPrint & "K"
                End Select
            Next
        End If
        If N_Dimension = 2.5 Then
            For J = 1 To 8 Step 2
                CurrentEncoding = Mid(nwPattern, J, 2)
                Select Case CurrentEncoding
                    Case "nn"
                        DataToPrint = DataToPrint & "W"
                    Case "nw"
                        DataToPrint = DataToPrint & "X"
                    Case "wn"
                        DataToPrint = DataToPrint & "Y"
                    Case "ww"
                        DataToPrint = DataToPrint & "Z"
                End Select
            Next
        End If
        If N_Dimension = 2 Then
            For J = 1 To 8 Step 2
                CurrentEncoding = Mid(nwPattern, J, 2)
                Select Case CurrentEncoding
                    Case "nn"
                        DataToPrint = DataToPrint & "A"
                    Case "nw"
                        DataToPrint = DataToPrint & "B"
                    Case "wn"
                        DataToPrint = DataToPrint & "E"
                    Case "ww"
                        DataToPrint = DataToPrint & "F"
                End Select
            Next
        End If
    Next I
    
    'the start character is wn and the stop is nwnw
    If N_Dimension = 3 Then IDAutomation_Uni_MSI = "I" & DataToPrint & "CC"
    If N_Dimension = 2.5 Then IDAutomation_Uni_MSI = "Y" & DataToPrint & "XX"
    If N_Dimension = 2 Then IDAutomation_Uni_MSI = "E" & DataToPrint & "BB"

End Function
Public Function IDAutomation_Uni_ProcessTilde(StringToProcess As String) As String
        IDAutomation_Uni_ProcessTilde = ""
        Dim OutString As String
        Dim CharsAdded As Integer
        StringLength = Len(StringToProcess)
        For I = 1 To StringLength
            If (I < StringLength - 2) And Mid(StringToProcess, I, 2) = "~m" And IsNumeric(Mid(StringToProcess, I + 2, 2)) Then
                Dim StringToCheck As String
                WeightValue = Val(Mid(StringToProcess, I + 2, 2))
                'Dim CharsAdded As Integer
                For J = I To 1 Step -1
                    If IsNumeric(Mid(OutString, J, 1)) Then
                        StringToCheck = StringToCheck & Mid(OutString, J, 1)
                        CharsAdded = CharsAdded + 1
                    End If
                    'when the number of digits added to StringToCheck equals the weight value exit the for loop
                    If CharsAdded = WeightValue Then
                        Exit For
                    End If
                Next J
                CheckDigitValue = MODU10(StrReverse(StringToCheck))
                OutString = OutString & ChrW(CheckDigitValue + 48)
                I = I + 3
            ElseIf (I < StringLength - 2) And Mid(StringToProcess, I, 1) = "~" And IsNumeric(Mid(StringToProcess, I + 1, 3)) Then
                CurrentCharNum = Val(Mid(StringToProcess, I + 1, 3))
                OutString = OutString & ChrW(CurrentCharNum)
                I = I + 3
            'This ElseIf was modified to support using () to add in AIs
            ElseIf (I < StringLength - 4) And Mid(StringToProcess, I, 1) = "(" And (Mid(StringToProcess, I + 2, 1) = ")" Or Mid(StringToProcess, I + 3, 1) = ")" Or Mid(StringToProcess, I + 4, 1) = ")" Or (Mid(StringToProcess, I + 5, 1) = ")" And (I < StringLength - 5)) Or (Mid(StringToProcess, I + 6, 1) = ")" And (I < StringLength - 6)) Or (Mid(StringToProcess, I + 7, 1) = ")" And (I < StringLength - 4)) Or (Mid(StringToProcess, I + 8, 1) = ")" And (I < StringLength - 4))) Then
                'Assign ASCII 212-217 depending on how many digits between ()
                If Mid(StringToProcess, I + 3, 1) = ")" Then OutString = OutString & ChrW(212)
                If Mid(StringToProcess, I + 4, 1) = ")" Then OutString = OutString & ChrW(213)
                If Mid(StringToProcess, I + 5, 1) = ")" Then OutString = OutString & ChrW(214)
                If Mid(StringToProcess, I + 6, 1) = ")" Then OutString = OutString & ChrW(215)
                If Mid(StringToProcess, I + 7, 1) = ")" Then OutString = OutString & ChrW(216)
                If Mid(StringToProcess, I + 8, 1) = ")" Then OutString = OutString & ChrW(217)
            'This ElseIf was modified to exclude ")" from being encoded
            ElseIf (I < StringLength - 2) And Mid(StringToProcess, I, 1) = ")" Then
                'Skip this character by breaking out of the else if
            Else
               OutString = OutString & Mid(StringToProcess, I, 1)
            End If
        Next I
        IDAutomation_Uni_ProcessTilde = OutString
        StringToProcess = ""
End Function

Public Function IDAutomation_Uni_Codabar(DataToEncode As String, Optional N_Dimension As Double = 2, Optional CodabarStart As String = "A", Optional CodabarStop As String = "B") As String
    CurrentEncoding = ""
    DataToPrint = ""
    OnlyCorrectData = ""
    SetCODABAR = Array("nnnnnwwn", "nnnnwwnn", "nnnwnnwn", "wwnnnnnn", "nnwnnwnn", "wnnnnwnn", "nwnnnnwn", "nwnnwnnn", "nwwnnnnn", "wnnwnnnn", "nnnwwnnn", "nnwwnnnn", "wnnnwnwn", "wnwnnnwn", "wnwnwnnn", "nnwnwnwn", "nnwwnwnn", "nwnwnnwn", "nnnwnwwn", "nnnwwwnn")
    '10 = "-", 11="$", 12 = ":", 13="/", 14= ".", 15="+", 16="A", 17="C", 18 = "D"
    If N_Dimension <> 3 And N_Dimension <> 2.5 Then N_Dimension = 2
    'Add start and stops
    DataToEncode = CodabarStart & DataToEncode & CodabarStop
    'Format the string to the universal font
    StringLength = Len(DataToEncode)
    WeightedTotal = 0
    For I = 1 To StringLength
        'Set CurrentValue to an invalid value by default
        CurrentValue = 99
        'Get the value of each number
        CurrentCharNum = (AscW(Mid(DataToEncode, I, 1)))
        'Get the CurrentValue
        '0-9
        If CurrentCharNum < 58 And CurrentCharNum > 47 Then CurrentValue = CurrentCharNum - 48
        '-
        If CurrentCharNum = 45 Then CurrentValue = 10
        '$
        If CurrentCharNum = 36 Then CurrentValue = 11
        ':
        If CurrentCharNum = 58 Then CurrentValue = 12
        '/
        If CurrentCharNum = 47 Then CurrentValue = 13
        '.
        If CurrentCharNum = 46 Then CurrentValue = 14
        '+
        If CurrentCharNum = 43 Then CurrentValue = 15
        'A
        If CurrentCharNum = 65 Or CurrentCharNum = 97 Then CurrentValue = 16
        'B
        If CurrentCharNum = 66 Or CurrentCharNum = 98 Then CurrentValue = 17
        'C
        If CurrentCharNum = 67 Or CurrentCharNum = 99 Then CurrentValue = 18
        'D
        If CurrentCharNum = 68 Or CurrentCharNum = 100 Then CurrentValue = 19

        'Retrieve the pattern, for example, 0 = "nwnwnwnw"
        If CurrentValue <> "99" Then nwPattern = SetCODABAR(CurrentValue)
        
        If N_Dimension = 3 And CurrentValue <> "99" Then
            For J = 1 To 8 Step 2
                CurrentEncoding = Mid(nwPattern, J, 2)
                Select Case CurrentEncoding
                    Case "nn"
                        DataToPrint = DataToPrint & "A"
                    Case "nw"
                        DataToPrint = DataToPrint & "C"
                    Case "wn"
                        DataToPrint = DataToPrint & "I"
                    Case "ww"
                        DataToPrint = DataToPrint & "K"
                End Select
            Next
        End If
        If N_Dimension = 2.5 And CurrentValue <> "99" Then
            For J = 1 To 8 Step 2
                CurrentEncoding = Mid(nwPattern, J, 2)
                Select Case CurrentEncoding
                    Case "nn"
                        DataToPrint = DataToPrint & "W"
                    Case "nw"
                        DataToPrint = DataToPrint & "X"
                    Case "wn"
                        DataToPrint = DataToPrint & "Y"
                    Case "ww"
                        DataToPrint = DataToPrint & "Z"
                End Select
            Next
        End If
        If N_Dimension = 2 And CurrentValue <> "99" Then
            For J = 1 To 8 Step 2
                CurrentEncoding = Mid(nwPattern, J, 2)
                Select Case CurrentEncoding
                    Case "nn"
                        DataToPrint = DataToPrint & "A"
                    Case "nw"
                        DataToPrint = DataToPrint & "B"
                    Case "wn"
                        DataToPrint = DataToPrint & "E"
                    Case "ww"
                        DataToPrint = DataToPrint & "F"
                End Select
            Next
        End If
    Next I

    IDAutomation_Uni_Codabar = DataToPrint

End Function

'*****************************************************************
'   Copyright, IDAutomation.com, Inc. All rights reserved.
'  Redistribution and use of this code in source and/or binary
'  forms, with or without modification, are permitted provided
'  that: (1) all copies of the source code retain the above
'  unmodified copyright notice and this entire unmodified
'  section of text, (2) You or Your organization owns a valid
'  Developer License to this product from IDAutomation.com
'  and, (3) when any portion of this code is bundled in any
'  form with an application, a valid notice must be provided
'  within the user documentation, start-up screen or in the
'  help-about section of the application that specifies
'  IDAutomation.com as the provider of the Software bundled
'  with the application.
'*****************************************************************
'Internal Version 2007.9.20
